﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Media.Imaging;

namespace KeyMaker
{
    class NumericPictureMaker:PictureMaker
    {


        protected new void WriteMainCharacter(string mainChar, StringFormat sf, int x, int y)
        {
            this.graphics.DrawString(mainChar, this.mainFont, this.mainBrush, x, y, sf);
        }

        protected void WriteSubCharacter(string subChar, int x, StringFormat sf)
        {            
            this.graphics.DrawString(subChar, this.subFont, this.subBrush, x, this.YSub, sf);
        }

        public override void CreatePicture(string mainChar, string subChar = "")
        {
            this.bitmap = new System.Drawing.Bitmap(this.width, this.height);
            this.graphics = Graphics.FromImage(this.bitmap);
            if (this.AntiAliasing)
            {
                this.graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                this.graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            }

            StringFormat sf = new StringFormat();
            sf.LineAlignment = StringAlignment.Center;
            sf.LineAlignment = StringAlignment.Near;
            int y = this.YMain;
            int mainx = this.width / 2 + 2;
            int subx = this.width / 2 - 8;
            if(subChar.Length == 4)
                subx = this.width / 2 - 12;
            if (subChar.Length > 0)
            {
                this.WriteSubCharacter(subChar,subx,sf);
                mainx -= 5;
                sf.Alignment = StringAlignment.Far;
            }
            else
            {
                y = this.YMain;
                mainx = this.width / 2;
                sf.Alignment = StringAlignment.Center;
            }
            
            
            this.WriteMainCharacter(mainChar, sf, mainx, y);
        }
    }
}
